package net.awired.ajsl.persistence.dao.interfaces.abstracts;

import java.io.Serializable;
import net.awired.ajsl.persistence.entity.interfaces.abstracts.IdEntity;
import org.hibernate.LockMode;
import org.springframework.dao.DataAccessException;

public interface DeleteDAO<ENTITY extends IdEntity<KEY_TYPE>, KEY_TYPE extends Serializable> {
    void removeAll() throws DataAccessException;

    void deleteAll() throws DataAccessException;

    void delete(ENTITY entity) throws DataAccessException;

    void delete(ENTITY entity, LockMode mode) throws DataAccessException;

}
