package net.awired.ajsl.persistence.dao.interfaces.abstracts;

import java.io.Serializable;
import net.awired.ajsl.persistence.entity.interfaces.abstracts.IdEntity;

public interface NestedSetDAO<ENTITY extends IdEntity<KEY_TYPE>, KEY_TYPE extends Serializable> {

    ENTITY findByLeftRight(KEY_TYPE idThread, Long left, Long right);

    ENTITY findByLeftRight(KEY_TYPE idThread, Long left, Long right, KEY_TYPE idToReturn);

    ENTITY findByLeft(KEY_TYPE idThread, Long left);

    ENTITY findByThread(KEY_TYPE thread);

    ENTITY findByThread(ENTITY thread);

    ENTITY findByIdWithSub(KEY_TYPE idNode);

    ENTITY findByIdWithTree(KEY_TYPE idNode);

}
