package net.awired.ajsl.persistence.entity.implementation.abstracts;

import java.io.Serializable;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.MappedSuperclass;
import net.awired.ajsl.persistence.entity.interfaces.abstracts.IdEntity;

@MappedSuperclass
public abstract class IdEntityImpl<KEY_TYPE extends Serializable> implements IdEntity<KEY_TYPE> {

    private static final long serialVersionUID = 1L;

    @Id
    @GeneratedValue
    protected KEY_TYPE        id;

    ///////////////////////////////////////////////////////////////////////////

    @Override
    public String toString() {
        return this.getClass().getName() + "[id=" + this.getId() + "]";
    }

    /**
     * TODO READ HIBERNATE DOC TO CHECK IF WELL IMPLEMENTED
     */
    @Override
    public int hashCode() {
        int hash = this.getClass().getName().hashCode() + this.getId().hashCode();
        return hash;
    }

    /**
     * TODO READ HIBERNATE DOC TO CHECK IF WELL IMPLEMENTED
     */
    @SuppressWarnings("unchecked")
    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        final IdEntityImpl<KEY_TYPE> other = (IdEntityImpl<KEY_TYPE>) obj;
        if (id == null) {
            if (other.id != null) {
                return false;
            }
        } else if (!id.equals(other.id)) {
            return false;
        }
        return true;
    }

    // ////////////////////////////////////////////////////////////////////////

    public KEY_TYPE getId() {
        return id;
    }

    public void setId(KEY_TYPE id) {
        this.id = id;
    }
}
